public class TCPClientTest 
{
    public static final int BUFFER_SIZE = 512;
    TCPClient client = null;
    byte[] sendData;
    byte[] receiveData;
    char[] tempCharData;
  
    TCPClientTest(TCPClient c) {
        client = c;
        sendData = new byte[BUFFER_SIZE];
        receiveData = new byte[BUFFER_SIZE];
        tempCharData = new char[BUFFER_SIZE];
    }

    public void paddingBytesArray(byte[] dest, int newSize, byte[] src, int size) {
	    for (int i = 0; i < size; i++) {
		    dest[i] = src[i];
	    }
	    for (int i = size; i < newSize; i++) {
		    dest[i] = 0;
	    }
    }
  
    public void send(String s) {
        if (client != null) {
            paddingBytesArray(sendData, BUFFER_SIZE, s.getBytes(), s.length());
            client.write(sendData, BUFFER_SIZE, true);	
	    }
    }
 
    public void receive() {
	    if (client != null) {
		    client.read(receiveData, BUFFER_SIZE, true);
        }
	    else {
		    System.out.println("Client is null");
	    }
    }

    public String getReceivedString() {
		int index;
		for (index = 0; index < receiveData.length; index++) {
			if (receiveData[index] != 0)
				tempCharData[index] = (char) receiveData[index];
			else 
				break;  // null character is hit			
		}
		String s = new String(tempCharData, 0, index);
		return s;
	}

    public void run() {
        System.out.println("TCPClientTest.run()");
   	    while (true) {
		    receive();
			String s = getReceivedString();
			System.out.println(s);
		    send("Received: " + s);
        }       
    }
}