import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.SocketException;
import java.net.UnknownHostException;

public class UDPSocket {
    final static int OK = 1;
    final static int FAILED = 2;
    InetAddress receivedAddress;
    int receivedPort;
    
    public UDPSocket() {
        try {
            cDS = new DatagramSocket();
        }
        catch (SocketException e) {
            System.out.println("UDPSocket: Creating a udp socket failed.\n"); 
        }
    }
    
    public UDPSocket(int port) {
        try {
          cDS = new DatagramSocket(port);
        }
        catch (SocketException e) {
            System.out.println("UDPSocket: Creating a udp socket failed.\n"); 
        }
    }
          
    public UDPSocket(InetAddress dest, int port) {        
        try {
            cDS = new DatagramSocket();
            setSendAddress(dest, port);
        }
        catch (SocketException e) {
            System.out.println("UDPSocket: Creating a udp socket failed.\n"); 
        }
    }

    public void close() {
        if (cDS != null) {
            cDS.close();
            cDS = null;
        }
    }
    
    public void setSendAddress(String dest, int port) {
        try {
            cDestAddr = InetAddress.getByName(dest);
        }
        catch (UnknownHostException e) {
        }
        this.cPort = port;        
    }

    public void setSendAddress(InetAddress dest, int port) {
        cDestAddr = dest;
        cPort = port;        
    }

    public void copyReceiveAddressToSendAddress() {
        setSendAddress(receivedAddress, receivedPort);
    }
       
    public int send(byte[] buffer, int size) {
        if (cDS != null) {
            DatagramPacket dp = new DatagramPacket(buffer, size, cDestAddr, cPort);
        
            if (dp != null) {
                try {
                    cDS.send(dp);
                }
                catch (IOException e) {
                    System.out.println("UDPSocket.send: Error occurred while sending a datagram packet.\n");                    
                    return 0;
                }
            }
        }
        return size;
    }
      				
    public byte[] receive(int size) {
        if (size > 0) {
            byte[] buffer = new byte[size];
            
            if (buffer != null) {
                DatagramPacket dp = new DatagramPacket(buffer, size);
                
                try {
                   receivedAddress = null;
                   receivedPort = 0;
                   cDS.receive(dp);
                   receivedAddress = dp.getAddress();
                   receivedPort = dp.getPort();
                }
                catch (IOException e) {
                    System.out.println("UDPSocket.receive: Error occurred while receiving a datagram packet.\n");
                    return null;
                }
                return buffer;
            }
        }
        return null;
    }

    DatagramSocket cDS = null;
    InetAddress cDestAddr = null;
    int cPort = 0;
}
    
    
                
